Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/EnumerableStatisticsExtension.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/EnumerableStatisticsExtension.cs	(revision 9998)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/EnumerableStatisticsExtension.cs	(revision 9998)
@@ -0,0 +1,43 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Analysis.Statistics {
+  //TODO: This should be moved to HeuristicLab.Common on trunk integration
+  public static class EnumerableStatisticExtensions {
+    public static Tuple<double, double> ConfidenceIntervals(this IEnumerable<double> values, double alpha) {
+      double lower, upper;
+      double s = values.StandardDeviation();
+      double x = values.Average();
+      int n = values.Count();
+      double t = alglib.studenttdistribution(n - 1, 1 - (alpha / 2));
+
+      lower = x - t * (s / Math.Sqrt(n));
+      upper = x + t * (s / Math.Sqrt(n));
+
+      return new Tuple<double, double>(lower, upper);
+    }
+  }
+}
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9968)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/HeuristicLab.Analysis.Statistics-3.3.csproj	(revision 9998)
@@ -120,4 +120,5 @@
   <ItemGroup>
     <Compile Include="BonferroniHolm.cs" />
+    <Compile Include="EnumerableStatisticsExtension.cs" />
     <Compile Include="ExpFitting.cs" />
     <Compile Include="IFitting.cs" />
Index: branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs
===================================================================
--- branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs	(revision 9968)
+++ branches/StatisticalTesting/HeuristicLab.Analysis.Statistics/3.3/SampleSizeInfluenceView.cs	(revision 9998)
@@ -267,5 +267,5 @@
 
     private void UpdateStatistics() {
-      DoubleMatrix matrix = new DoubleMatrix(9, seriesCache.Count);
+      DoubleMatrix matrix = new DoubleMatrix(11, seriesCache.Count);
       matrix.SortableView = false;
       List<string> columnNames = new List<string>();
@@ -297,5 +297,5 @@
       }
       matrix.ColumnNames = columnNames;
-      matrix.RowNames = new string[] { "Count", "Minimum", "Maximum", "Average", "Median", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile" };
+      matrix.RowNames = new string[] { "Count", "Minimum", "Maximum", "Average", "Median", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile", "Lower Confidence", "Upper Confidence" };
 
       for (int i = 0; i < seriesCache.Count; i++) {
@@ -311,4 +311,6 @@
         matrix[7, i] = seriesValues.Percentile(0.25);
         matrix[8, i] = seriesValues.Percentile(0.75);
+        matrix[9, i] = seriesValues.ConfidenceIntervals(0.95).Item1;
+        matrix[10, i] = seriesValues.ConfidenceIntervals(0.95).Item2;
       }
       statisticsMatrixView.Content = matrix;