Index: /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceProviderView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceProviderView.cs	(revision 10008)
+++ /trunk/sources/HeuristicLab.Problems.Instances.DataAnalysis.Views/3.3/DataAnalysisInstanceProviderView.cs	(revision 10009)
@@ -29,5 +29,5 @@
 namespace HeuristicLab.Problems.Instances.DataAnalysis.Views {
   [View("DataAnalysis InstanceProvider View")]
-  public partial class DataAnalysisInstanceProviderView<T> : ProblemInstanceProviderViewGeneric<T>
+  public partial class DataAnalysisInstanceProviderView<T> : ProblemInstanceProviderView<T>
     where T : class, IDataAnalysisProblemData {
 
Index: /trunk/sources/HeuristicLab.Problems.Instances.TSPLIB.Views/3.3/TSPLIBTSPInstanceProviderView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.TSPLIB.Views/3.3/TSPLIBTSPInstanceProviderView.cs	(revision 10008)
+++ /trunk/sources/HeuristicLab.Problems.Instances.TSPLIB.Views/3.3/TSPLIBTSPInstanceProviderView.cs	(revision 10009)
@@ -29,5 +29,5 @@
   [View("TSPLIB TSP InstanceProvider View")]
   [Content(typeof(TSPLIBTSPInstanceProvider), IsDefaultView = true)]
-  public partial class TSPLIBTSPInstanceProviderView : ProblemInstanceProviderViewGeneric<TSPData> {
+  public partial class TSPLIBTSPInstanceProviderView : ProblemInstanceProviderView<TSPData> {
     public new TSPLIBTSPInstanceProvider Content {
       get { return (TSPLIBTSPInstanceProvider)base.Content; }
Index: /trunk/sources/HeuristicLab.Problems.Instances.VehicleRouting.Views/3.4/VRPInstanceProviderView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.VehicleRouting.Views/3.4/VRPInstanceProviderView.cs	(revision 10008)
+++ /trunk/sources/HeuristicLab.Problems.Instances.VehicleRouting.Views/3.4/VRPInstanceProviderView.cs	(revision 10009)
@@ -30,5 +30,5 @@
   [View("VRP InstanceProvider View")]
   [Content(typeof(IProblemInstanceProvider<IVRPData>), IsDefaultView = true)]
-  public partial class VRPInstanceProviderView<T> : ProblemInstanceProviderViewGeneric<T> where T : class, IVRPData {
+  public partial class VRPInstanceProviderView<T> : ProblemInstanceProviderView<T> where T : class, IVRPData {
 
     public VRPInstanceProviderView() {
Index: /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs	(revision 10008)
+++ /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.Designer.cs	(revision 10009)
@@ -22,5 +22,5 @@
 
 namespace HeuristicLab.Problems.Instances.Views {
-  partial class ProblemInstanceProviderViewGeneric<T> {
+  partial class ProblemInstanceProviderView<T> {
     /// <summary> 
     /// Required designer variable.
Index: /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs	(revision 10008)
+++ /trunk/sources/HeuristicLab.Problems.Instances.Views/3.3/ProblemInstanceProviderViewGeneric.cs	(revision 10009)
@@ -34,5 +34,5 @@
   [View("ProblemInstanceProviderViewGeneric")]
   [Content(typeof(IProblemInstanceProvider<>), IsDefaultView = true)]
-  public partial class ProblemInstanceProviderViewGeneric<T> : ProblemInstanceProviderView {
+  public partial class ProblemInstanceProviderView<T> : ProblemInstanceProviderView {
 
     public new IProblemInstanceProvider<T> Content {
@@ -64,5 +64,5 @@
     #endregion
 
-    public ProblemInstanceProviderViewGeneric() {
+    public ProblemInstanceProviderView() {
       InitializeComponent();
       importButton.Text = String.Empty;